'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A test program to use inline ASM to change
' text to uppercase using a Ucase$() function.
' This demo shows that strings can be modified
' and returned using inline ASM within a function.
' Note: Changed to use CODE/END CODE statements
'
PROGRAM	"ucase"
'VERSION	"0.0003"	' modified 16 Oct 05 for goasm
VERSION "0.0004"  ' modifed  12 Feb 20 to use CODE/END CODE statements
CONSOLE
'
	IMPORT	"xst"
'
DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  Ucase$ (text$)
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	text$ = "ThIs Is a test StrInG"
	PRINT text$

	t$ = Ucase$ (text$)
	PRINT t$

	a$ = INLINE$ ("Press RETURN to QUIT >")

END FUNCTION
'
'
' #######################
' #####  Ucase$ ()  #####
' #######################
'
FUNCTION  Ucase$ (text$)

	x$ = text$										' string to modify and return

CODE
mov				esi,[Ucase$.x$]		;	string address of 1st character
mov				eax,[Ucase$.x$]		;	string address of 1st character
sub				eax,8							; string length at stringAddr - 0x08
mov				ebx,[eax]					; get string length

Next:
dec				ebx								; point to the next prior character
js	>			Exit							; jump if sign is negative ebx is < 0
mov				al,[ebx+esi]			; put the current character into al
cmp				al,'a'						; compare char to 'a'
jb	<			Next							; jump if below to Next
cmp				al,'z'					  ; compare char to 'z'
ja	<			Next							; jump if above to Next
sub				al,0x20					  ; convert to upper case
mov				[ebx+esi],al			; put al back into string
jmp	<			Next							; jump to Next

Exit:
END CODE

	RETURN x$

END FUNCTION
END PROGRAM
