' does not need the m4 preprocessor

'# A demo of using sapi speech api to read text. Requires using ComX library and m4 preprocessor.

VERSION "0.0001"
CONSOLE
'# MAKEFILE "pelles.xxx"

	IMPORT "xst"
	IMPORT "xsx"
	IMPORT "kernel32"
	IMPORT "ole32"
	IMPORT "oleaut32"
	IMPORT "sapi"

'# #############################################################################
'# ComX_access.m4
'# COM access macros for XBlite
'# Import with m4_include(`ComX_access.m4'), remember to enable macros when compiling
'#
'# Note my conventions for the Expands to section:
'# brackets [] denote optionality
'# braces {} denote that the contents should be a macro
'#
'# COMX macros use the following variables:
'# COMX_temp					You may need to declare this manually if you use the EXPLICIT keyword
'# COMX_TYPE_<type>		where type is some interface structure
'# hr									Return value from CC.  CC only works for COM methods with 4 byte returns
'#
'# #############################################################################

'# #############################################################################
'# FAILED (hr)
'#
'# Returns 0 if hr represents success, otherwise it returns non 0
'# #############################################################################


'# #############################################################################
'# COMOBJ (type, name)
'#
'# Use at start of function with other declarations
'# can be prefixed with SHARED, STATIC or other scope identifier as necassary
'#
'# Expands to:
'#  XLONG name\n
'#  [type COMX_TYPE_type]
'#
'# Defines sub macros:
'#  COMX_TYPEDEF_type		(used to detect whether or not COMX_TYPE_type has been declared)
'#	name_TYPE						(used to detect the type for a COM call)
'# #############################################################################



'# #############################################################################
'# CC (obj::method, p1, p2, ... pn-1, pn)
'#
'# Use to call a COM method
'# Return value is stored in variable hr
'#
'# Expands to:
'#  COMX_temp = &{obj_TYPE}
'#  XLONGAT(&&{obj_TYPE}) = XLONGAT(obj)
'#  hr = @obj_TYPE.method(obj, p1, p2, ... pn-1, pn)
'#  XLONGAT(&&{obj_TYPE}) = COMX_temp
'#
'# Defines sub macros:
'#  _COMX_OBJ
'#  _COMX_METHOD
'#  _COMX_OBJTYPE
'# #############################################################################



'# #############################################################################
'# DECLARE_EXTERN_IMPORTERS (v1, v2, ... vn-1, vn)
'#
'# Declares a function to import an external variable
'#
'# Expands to:
'#  DECLARE FUNCTION READ_v1 ()
'#  DECLARE FUNCTION READ_v2 ()
'#	...
'#  DECLARE FUNCTION READ_vn-1 ()
'#  DECLARE FUNCTION READ_vn ()
'# #############################################################################


'# #############################################################################
'# DEFINE_EXTERN_IMPORTERS (v1, v2, ... vn-1, vn)
'#
'# Defines a function to import an external variable
'#
'# Expands to:
'#  FUNCTION READ_v1 ()
'#  	XLONG pExtern
'#  ASM mov [READ_v1.pExtern], _v1
'#  	RETURN pExtern
'#  END FUNCTION
'#  FUNCTION READ_v2 ()
'#  	XLONG pExtern
'#  ASM mov [READ_v1.pExtern], _v2
'#  	RETURN pExtern
'#  END FUNCTION
'#  ...
'# #############################################################################


'# #############################################################################
'# Tests
'# COMOBJ(IExample, pExample)
'# ###
'# CC(pExample::SomeMethod, p1, p2, p3)
'# ###
'# DECLARE_EXTERN_IMPORTER(IID_IExample)
'# ###
'# DEFINE_EXTERN_IMPORTER(IID_IExample)


DECLARE FUNCTION Entry ()

DECLARE FUNCTION READ_CLSID_SpVoice ()
DECLARE FUNCTION READ_IID_ISpVoice ()

FUNCTION Entry ()

		XLONG pVoice
	ISpVoice COMX_TYPE_ISpVoice

  IF ((CoInitialize (0)) AND 0x80000000) THEN
		PRINT "CoInitialise failed"
		RETURN 1
	END IF

	hr = CoCreateInstance (READ_CLSID_SpVoice(), 0, $$CLSCTX_ALL, READ_IID_ISpVoice(), &pVoice)
	IF ((hr) AND 0x80000000) THEN
		PRINT "Failed to create ISpVoice interface"
		GOTO CleanUp
	END IF

	hello$ = XstAnsiToUnicode$ ("Hello world.")
	? "Hello world."

		' pVoice::Speak,&hello$,0,0
	COMX_temp = &COMX_TYPE_ISpVoice
	XLONGAT(&&COMX_TYPE_ISpVoice) = XLONGAT(pVoice)
	hr = @COMX_TYPE_ISpVoice.Speak(pVoice , &hello$,0,0)
	XLONGAT(&&COMX_TYPE_ISpVoice) = COMX_temp
	IF ((hr) AND 0x80000000) THEN
		PRINT "Could not get ISpVoice interface to speak"
		GOTO CleanUp
	END IF

CleanUp:
	IF pVoice THEN
			' pVoice::Release
	COMX_temp = &COMX_TYPE_ISpVoice
	XLONGAT(&&COMX_TYPE_ISpVoice) = XLONGAT(pVoice)
	hr = @COMX_TYPE_ISpVoice.Release(pVoice  )
	XLONGAT(&&COMX_TYPE_ISpVoice) = COMX_temp
	END IF

	CoUninitialize()

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION READ_CLSID_SpVoice ()
	XLONG pExtern
ASM mov eax, ADDR _CLSID_SpVoice
ASM mov [READ_CLSID_SpVoice.pExtern], eax
	RETURN pExtern
END FUNCTION
FUNCTION READ_IID_ISpVoice ()
	XLONG pExtern
ASM mov eax, ADDR _IID_ISpVoice
ASM mov [READ_IID_ISpVoice.pExtern], eax
	RETURN pExtern
END FUNCTION

END PROGRAM
