'
' ####################
' #####  PROLOG  #####
' ####################
'
' Example of using text array functions XstFindArray, XstReplaceArray, XstDeleteLines, and XstParseWhitespaceToArray
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

' IMPORT "gdi32"			' gdi32.dll
'	IMPORT "user32"		  ' user32.dll
'	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

'
DECLARE FUNCTION Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	DIM preamble$[8]
	DIM lyrics$[11]

	preamble$[0] = "We the People of the United States, "
	preamble$[1] = "in Order to form a more perfect Union, "
	preamble$[2] = "establish Justice and insure domestic Tranquility, " 
	preamble$[3] = "and provide for the common defence, "
	preamble$[4] = "and promote the general Welfare, "
	preamble$[5] = "and secure the Blessings of Liberty to "
	preamble$[6] = "ourselves and our Posterity, "
	preamble$[7] = "do ordain and establish this Constitution "
	preamble$[8] = "for the United States of America."
	
	lyrics$[0] = "One pill makes you larger"
	lyrics$[1] = "And one pill makes you small"
	lyrics$[2] = "And the ones that mother gives you"
	lyrics$[3] = "Don't do anything at all"
	lyrics$[4] = "Go ask Alice"
	lyrics$[5] = "When she's ten feet tall"
	lyrics$[6] = "And if you go chasing rabbits"
	lyrics$[7] = "And you know you're going to fall"
	lyrics$[8] = "Tell 'em a hookah-smoking caterpillar"
	lyrics$[9] = "Has given you the call"
	lyrics$[10] = "Call Alice"
	lyrics$[11] = "When she was just small"
	
	' find some text in array
	mode = 0
	find$ = "small"
	length = LEN(find$)
	' find all cases of "small"
	DO
		XstFindArray (mode, @lyrics$[], @find$, @line, @pos, @match)
		IF match THEN 
			pos = pos + length		' move position past matching text to continue search
			? "match = "; match; ": found a match in line"; line; " at position"; pos
		END IF 
	LOOP WHILE match == $$TRUE
	
	?
	' find and replace some text in an array
	find$ = "and"
	replace$ = "&"
	length = LEN(replace$)
	match = 0
	line = 0
	pos = 0
	DO
		XstReplaceArray (mode, @preamble$[], @find$, @replace$, @line, @pos, @match)
		IF match THEN 
			pos = pos + length		' move position past matching replacement text to continue search
		? "match = "; match; ": found a match in line"; line; " at position"; pos
		END IF 
	LOOP WHILE match == $$TRUE
	?
	upp = UBOUND (preamble$[])
	FOR i = 0 TO upp
		? preamble$[i]
	NEXT i
	
	?
	
	'delete some lines in an array
	XstDeleteLines (@lyrics$[], 7, 3)
	upp = UBOUND (lyrics$[])
	FOR i = 0 TO upp
		? lyrics$[i]
	NEXT i
	
	?
	
	' copy text array into a single string
	XstStringArrayToString (@preamble$[], @s$)
	
	' parse string into words
	XstParseWhitespaceToArray (@s$, @words$[])
	
	upp = UBOUND(words$[])

	f$ = "<<<<<<<<<<<<<<<<"
	count = 0
	FOR i = 0 TO upp
		s$ = FORMAT$(f$, words$[i])
		? s$;
		INC count
		IF count = 4 THEN 
			count = 0
			PRINT
		END IF 
	NEXT i
	
	?
	
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM