'
' ####################
' #####  PROLOG  #####
' ####################
'
' test a call to kernel32.dll function GetPhysicallyInstalledSystemMemory using golink
' this function is not included in the current kernel32.lib so it shows
' that golink finds the function in kernel32.dll
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput LIBRARY

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

' IMPORT "gdi32"			' gdi32.dll
'	IMPORT "user32"		  ' user32.dll
	IMPORT "kernel32.dec"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION GetPhysicallyInstalledRAM ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	ram = GetPhysicallyInstalledRAM ()
	
	? "Installed RAM = "; ram; "MB"
	? "Installed RAM = "; ram/1024; "GB"

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION

FUNCTION GetPhysicallyInstalledRAM ()

	ULONG ram   ' total memory in kilobytes
	err = GetPhysicallyInstalledSystemMemory (&ram) ' returns kb
	ram = ram/1024  'MBs
	IF ram THEN RETURN XLONG(ram)
	
END FUNCTION
END PROGRAM