'	scrollingtext.x
'	A Simple Console Scrolling Text Program
'	Chandra MDE - chandramde at telkom dot net

CONSOLE

IMPORT "xio"
IMPORT "xsx"
IMPORT "kernel32.dll"

DECLARE FUNCTION Entry()

FUNCTION Entry()

	Title$ = "Scrolling Text - By Chandra MDE"
	S$ = "XBLite is one of the best BASIC Compiler"


	'A Little Initialization
	SUB Init
		SetConsoleTitleA(&Title$)

		hSO = XioGetStdOut()
		XioClearConsole(hSO)
		XioSetCursorType(hSO, $$NOCURSOR)
	END SUB

	'A Scrolling Text is on the way...
	SUB Scroll
		xcursorpos = 0
		ycursorpos = 12
		lengthoftext = LEN (S$)
		textcolor = 1

		DO
			XioSetConsoleCursorPos(hSO, 0, ycursorpos)
			XioDeleteLine(hSO)
			XioSetTextColor(hSO, textcolor)

			INC xcursorpos
			deltax = 80 - lengthoftext - xcursorpos
			IF deltax < 0 THEN
				IF deltax = -lengthoftext THEN xcursorpos = 0

				S1$ = RIGHT$ (S$, deltax*-1)
				S2$ = LEFT$ (S$, lengthoftext+deltax)
				XioWriteConsole(hSO, S1$)
			ELSE
				S2$ = S$
			END IF

			XioSetConsoleCursorPos(hSO, xcursorpos, ycursorpos)
			XioWriteConsole(hSO, S2$)
			XstSleep(150)

			INC textcolor
			IF textcolor>15 THEN textcolor = 1
		LOOP UNTIL XioInkey() <> 0
	END SUB

	GOSUB Init
	GOSUB Scroll

	XioSetCursorType(hSO, $$NORMALCURSOR)
	XioCloseStdHandle(hSO)

END FUNCTION
END PROGRAM
