'
' ####################
' #####  PROLOG  #####
' ####################
'
' A console program template
'
VERSION "0.0001"
CONSOLE
'
	IMPORT "xst"				' Standard library : required by most programs
	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput library

'	IMPORT "xst_s.lib"
' IMPORT "xsx_s.lib"
' IMPORT "xio_s.lib"

' IMPORT "gdi32"			' gdi32.dll
'	IMPORT "user32"		  ' user32.dll
'	IMPORT "kernel32"	  ' kernel32.dll
'	IMPORT "shell32"		' shell32.dll
'	IMPORT "msvcrt"		  ' msvcrt.dll

'
DECLARE FUNCTION Entry ()
DECLARE FUNCTION CreateUUID$ ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	FOR i = 0 TO 19
		uuid$ = CreateUUID$ ()
		PRINT uuid$
	NEXT i
  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
'
' #########################
' #####  CreateUUID$  #####
' #########################
'
'	Create a unique GUID
'
FUNCTION CreateUUID$ ()

' y is one of [89AB]
' format of UUID is xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx

	uuid$ = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx"
	hex$ = "0123456789ABCDEF"
	upp = LEN (uuid$) - 1

	FOR i = 0 TO upp

    r = XstRandomRange (1, 16)
    c = ' '

    SELECT CASE uuid${i}
      CASE 'x' : c = hex${r-1}
      CASE 'y' : c = hex${r & 0x03 | 0x08}
      CASE '-' : c = '-'
      CASE '4' : c = '4'
    END SELECT

		uuid${i} = c

	NEXT i
	RETURN uuid$

END FUNCTION
END PROGRAM