'************************************************************
' XSWEEPER
' By Chandra MDE
' http://telinks.wordpress.com/category/software/xblite/
' chandramde@telkom.net
'************************************************************

PROGRAM "xsweeper"
CONSOLE


IMPORT "xio"
IMPORT "xsx"
IMPORT "xst"
IMPORT "kernel32"
IMPORT "gdi32"
IMPORT "user32"


$$BOMB = -1
$$EMPTY = 0


DECLARE FUNCTION MainProgram()
DECLARE FUNCTION PutTextAttributes (hStdOut, attribute, length, x, y)


FUNCTION MainProgram()
	
	SBYTE Cell[16, 12]
	UBYTE CellStatus[16, 12]
	
	COORD coord
	
	Title$ = "X-SWEEPER - By Chandra MDE"
	
	DIM B$[25]
	
	B$[0] = "Ŀ"
	B$[1] = "                                                ͸"
	B$[2] = "Ŵ  XSWEEPER  ô"
	B$[3] = "                                                ;"
	B$[4] = "Ĵ              "
	B$[5] = "                                                ͸"
	B$[6] = "Ŵ     By     ô"
	B$[7] = "                                                 ChandraMDE "
	B$[8] = "Ŵ XBLite-Pro ô"
	B$[9] = "                                                ;"
	B$[10]= "Ĵ              "
	B$[11]= "                                                ͸"
	B$[12]= "Ŵ   STATUS   ô"
	B$[13]= "                                                ͵"
	B$[14]= "Ĵ XMine [  ] "
	B$[15]= "                                                 Found [  ] "
	B$[16]= "Ĵ Left  [  ] "
	B$[17]= "                                                 Skor[    ] "
	B$[18]= "Ŵ"
	B$[19]= "                                                  "
	B$[20]= "Ĵٳ"
	B$[21]= "                                                 VISIT MYBLOG "
	B$[22]= "Ĵ   /telinks   "
	B$[23]= "                                                  @WordPress  "
	B$[24]= ""
	
	
	'*********************************
	'Program Initialization Subroutine
	'*********************************
	SUB InitProgram
		DIM args[2]
		
		hSO = XioGetStdOut()
		XioSetCursorType(hSO, $$NOCURSOR)
		SetConsoleTitleA(&Title$)
		XioClearConsole(hSO)
		XioSetConsoleBufferSize(hSO, 80, 25)
'		hCon = XioGetConsoleWindow ()
'		SetWindowPos (hCon, $$HWND_TOP, 200, 100, 700, 600, $$SWP_FRAMECHANGED)
		
		args[0] = hSO
		args[1] = 1   ' 1 = fullscreen, 2 = console window
		args[2] = &coord
		
'		XstCall("SetConsoleDisplayMode", "kernel32.dll", @args[])
		
		FOR i = 0 TO 24
			XioPutConsoleText(hSO, B$[i], 0, i)
		NEXT 
		
		FillConsoleOutputAttribute (hSO, 0x0F, 0xFFFFFF, 0, &written)
		
		FOR x = 66 TO 77
			PutTextAttributes(hSO, 14, 1, x, 2)
			PutTextAttributes(hSO, 14, 1, x, 6)
			PutTextAttributes(hSO, 10, 1, x, 7)
			PutTextAttributes(hSO, 12, 1, x, 8)
			PutTextAttributes(hSO, 14, 1, x, 12)
			PutTextAttributes(hSO, 13, 1, x, 14)
			PutTextAttributes(hSO, 9, 1, x, 15)
			PutTextAttributes(hSO, 12, 1, x, 16)
			PutTextAttributes(hSO, 11, 1, x, 17)
			PutTextAttributes(hSO, 13, 1, x, 21)
			PutTextAttributes(hSO, 14, 1, x, 22)
			PutTextAttributes(hSO, 10, 1, x, 23)
		NEXT 
	END SUB 
	
	
	'***********************
	'Exit Program Subroutine
	'*********************** 
	SUB ExitProgram
		XioClearConsole(hSO)
		XioSetTextColor(hSO, 11)
		XioWriteConsole(hSO, "Thank you for playing this game.\n\n")
		XioWriteConsole(hSO, "Find out more fun XBLite programs at\n\n")
		XioWriteConsole(hSO, "     http://telinks.wordpress.com/category/software/xblite/\n\n\n\n")
		XioWriteConsole(hSO, "Regards,\n")
		XioWriteConsole(hSO, "Chandra MDE\n")
		XioWriteConsole(hSO, "Email: chandramde@telkom.net\n")
		XioWriteConsole(hSO, "Phone: +62 341 9857624\n")
		
		DO : LOOP WHILE XioInkey() = 0
		XioCloseStdHandle(hSO)
	END SUB 
	
	
	'**************************
	'Subrutin Inisialisasi Cell
	'**************************
	SUB InitCell
		FOR x = 0 TO 15
			FOR y = 0 TO 11
				Cell[x, y] = 0
				CellStatus[x, y] = 0
			NEXT
		NEXT
		
		JumlahRanjau = XstRandomRange(20, 45)
		
		FOR i = 1 TO JumlahRanjau
			x = XstRandomRange(0, 15)
			y = XstRandomRange(0, 11)
			Cell[x, y] = -1
		NEXT 
		
		Skor = 0
		Ketemu = 0
		Sisa = JumlahRanjau
		
		FOR x = 0 TO 15
			FOR y = 0 TO 11
				IF Cell[x, y] = -1 THEN DO NEXT
				
				nb = 0
				xp = x + 1
				xm = x - 1
				yp = y + 1
				ym = y - 1
				
				IF xp<=15 THEN
					IF Cell[xp, y] = -1 THEN INC nb
				END IF 
				
				IF xm>=0 THEN
					IF Cell[xm, y] = -1 THEN INC nb
				END IF
				
				IF yp<=11 THEN
					IF Cell[x, yp] = -1 THEN INC nb
				END IF
				
				IF ym>=0 THEN
					IF Cell[x, ym] = -1 THEN INC nb
				END IF
				
				IF (xp<=15) AND (yp<=11) THEN
					IF Cell[xp, yp] = -1 THEN INC nb
				END IF
				
				IF (xp<=15) AND (ym>=0) THEN
					IF Cell[xp, ym] = -1 THEN INC nb
				END IF
				
				IF (xm>=0) AND (yp<=11) THEN
					IF Cell[xm, yp] = -1 THEN INC nb
				END IF
				
				IF (xm>=0) AND (ym>=0) THEN
					IF Cell[xm, ym] = -1 THEN INC nb
				END IF
				
				Cell[x, y] = nb
			NEXT 
		NEXT 
	END SUB 
	
	
	'****************************
	'Print the status of the game
	'****************************
	SUB PrintStatus
		XioSetTextColor(hSO, 14)
		XioSetConsoleCursorPos(hSO, 74, 14)
		XioWriteConsole(hSO, FORMAT$ ("##", JumlahRanjau))
		XioSetConsoleCursorPos(hSO, 74, 15)
		XioWriteConsole(hSO, FORMAT$ ("##", Ketemu))
		XioSetConsoleCursorPos(hSO, 74, 16)
		XioWriteConsole(hSO, FORMAT$ ("##", Sisa))
		XioSetConsoleCursorPos(hSO, 72, 17)
		XioWriteConsole(hSO, FORMAT$ ("####", Skor))
	END SUB 
	
	
	'*********************************
	'Show All Cells
	'*********************************
	SUB PrintCell
		FOR x = 0 TO 15
			FOR y = 0 TO 11
				XioSetConsoleCursorPos(hSO, 2+x*4, 1+2*y)
				SELECT CASE Cell[x, y]
					CASE -1
						XioSetTextColor(hSO, 12)
						XioWriteConsole(hSO, CHR$ (1))
					CASE 0
						XioSetTextColor(hSO, 7)
						XioWriteConsole(hSO, CHR$ (249))
					CASE ELSE 
						XioSetTextColor(hSO, 8+Cell[x, y])
						XioWriteConsole(hSO, FORMAT$ ("#", Cell[x, y]))
				END SELECT 
			NEXT
		NEXT 
	END SUB
	
	
	'**********************************
	'Show Closed Cells
	'**********************************
	SUB PrintClosedCell
		XioSetTextColor(hSO, 4)
		XioSetTextBackColor(hSO, 0)
		FOR x = 0 TO 15
			FOR y = 0 TO 11
				XioSetConsoleCursorPos(hSO, 4*x+2, 2*y+1)
				XioWriteConsole(hSO, CHR$ (254))
			NEXT
		NEXT 
	END SUB 
	
	
	'****************************
	'Let's playing the game...
	'****************************
	SUB Playing
		px = 7
		py = 5
		
		DO 
			GOSUB PrintStatus
			
			IF Sisa = 0 THEN
				XioSetTextColor(hSO, 14)
				XioSetConsoleCursorPos(hSO, 67, 19)
				XioWriteConsole(hSO, "YOU WIN!!!")
				
				DO 
					FOR i = 1000 TO 1500 STEP 20
						Beep(i, 1)
					NEXT
					FOR i = 1000 TO 1500 STEP 10
						Beep(i, 1)
					NEXT
					FOR i = 1500 TO 1250 STEP -20
						Beep(i, 1)
					NEXT
				LOOP WHILE XioInkey() = 0
				
				XioSetTextColor(hSO, 15)
				XioSetConsoleCursorPos(hSO, 67, 19)
				XioWriteConsole(hSO, "")
			END IF 
			
			'***********************************
			'Blinking Pointer and Wait For A Key
			'***********************************
			DO
				PutTextAttributes(hSO, 1, 1, 4*px+1, 2*py)
				PutTextAttributes(hSO, 1, 1, 4*px+2, 2*py)
				PutTextAttributes(hSO, 1, 1, 4*px+3, 2*py)
				PutTextAttributes(hSO, 1, 1, 4*px+1, 2*py+2)
				PutTextAttributes(hSO, 1, 1, 4*px+2, 2*py+2)
				PutTextAttributes(hSO, 1, 1, 4*px+3, 2*py+2)
				PutTextAttributes(hSO, 1, 1, 4*px, 2*py+1)
				PutTextAttributes(hSO, 1, 1, 4*px+4, 2*py+1)
				
				IF CellStatus[px, py] = 0 THEN
					XioSetTextColor(hSO, 1)
					XioSetConsoleCursorPos(hSO, 4*px+2, 2*py+1)
					XioWriteConsole(hSO, "\\")
					Sleep(25)
				
					XioSetConsoleCursorPos(hSO, 4*px+2, 2*py+1)
					XioWriteConsole(hSO, CHR$ (196))
					Sleep(25)
				
					XioSetConsoleCursorPos(hSO, 4*px+2, 2*py+1)
					XioWriteConsole(hSO, "/")
				ELSE
					Sleep(50)
				END IF 
				
				PutTextAttributes(hSO, 15, 1, 4*px+1, 2*py)
				PutTextAttributes(hSO, 15, 1, 4*px+2, 2*py)
				PutTextAttributes(hSO, 15, 1, 4*px+3, 2*py)
				PutTextAttributes(hSO, 15, 1, 4*px+1, 2*py+2)
				PutTextAttributes(hSO, 15, 1, 4*px+2, 2*py+2)
				PutTextAttributes(hSO, 15, 1, 4*px+3, 2*py+2)
				PutTextAttributes(hSO, 15, 1, 4*px, 2*py+1)
				PutTextAttributes(hSO, 15, 1, 4*px+4, 2*py+1)
				Sleep(50)
				
				KEY = XioInkey()
			LOOP UNTIL KEY <> 0
			
			IF CellStatus[px, py] = 0 THEN 
				XioSetTextColor(hSO, 4)
				XioSetConsoleCursorPos(hSO, 4*px+2, 2*py+1)
				XioWriteConsole(hSO, CHR$ (254))
			END IF 
				
			'What key?
			SELECT CASE KEY
				CASE -72	'UP
					Beep(400, 5)
					DEC py
					IF py = -1 THEN py = 11
					
				CASE -80 'DOWN
					Beep(200, 5)
					INC py
					IF py = 12 THEN py = 0
					
				CASE -77 'RIGHT
					Beep(300, 5)
					INC px
					IF px = 16 THEN px = 0
					
				CASE -75 'LEFT
					Beep(300, 5)
					DEC px
					IF px = -1 THEN px = 15
					
				CASE 32 'SPACE
					XioSetConsoleCursorPos(hSO, 4*px+2, 1+2*py)
					SELECT CASE Cell[px, py]
						CASE $$BOMB		'bomb
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 10, 1, x, 19)
							NEXT 
						
							GOSUB PrintCell
							DO
								Beep(500, 500)
								Beep(800, 500)
							LOOP WHILE XioInkey() = 0
							GOSUB InitCell
							GOSUB PrintClosedCell
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 15, 1, x, 19)
							NEXT 
										
						CASE $$EMPTY		'empty cell
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 10, 1, x, 19)
							NEXT 
							
							XioSetTextColor(hSO, 14)
							XioWriteConsole(hSO, CHR$ (249))
							CellStatus[px, py] = 1
							
							FOR i = 1000 TO 1500 STEP 50
								Beep(i, 1)
							NEXT
							FOR i = 1000 TO 1500 STEP 30
								Beep(i, 1)
							NEXT
							FOR i = 1500 TO 1250 STEP -50
								Beep(i, 1)
							NEXT
							
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 15, 1, x, 19)
							NEXT 
							
							pxe = px : pye = py
							DO
								INC pxe
								IF pxe<=15 THEN
									IF Cell[pxe, pye] = 0 THEN
										XioSetConsoleCursorPos(hSO, 4*pxe+2, 1+2*pye)
										XioSetTextColor(hSO, 14)
										XioWriteConsole(hSO, CHR$ (249))
										CellStatus[pxe, pye] = 1
										Beep(400, 5)
										Sleep(100)
									ELSE
										EXIT DO
									END IF 
								END IF 
							LOOP UNTIL pxe > 15
							
							pxe = px
							DO
								INC pye
								IF pye<=11 THEN
									IF Cell[pxe, pye] = 0 THEN
										XioSetTextColor(hSO, 14)
										XioSetConsoleCursorPos(hSO, 4*pxe+2, 1+2*pye)
										XioWriteConsole(hSO, CHR$ (249))
										CellStatus[pxe, pye] = 1
										Beep(400, 5)
										Sleep(100)
									ELSE
										EXIT DO
									END IF 
								END IF 
							LOOP UNTIL pye > 11
							
							pye = py
							DO
								DEC pxe
								IF pxe>=0 THEN
									IF Cell[pxe, pye] = 0 THEN
										XioSetTextColor(hSO, 14)
										XioSetConsoleCursorPos(hSO, 4*pxe+2, 1+2*pye)
										XioWriteConsole(hSO, CHR$ (249))
										CellStatus[pxe, pye] = 1
										Beep(400, 5)
										Sleep(100)
									ELSE
										EXIT DO
									END IF 
								END IF 
							LOOP UNTIL pxe < 0
							
							pxe = px
							DO
								DEC pye
								IF pye>=0 THEN
									IF Cell[pxe, pye] = 0 THEN
										XioSetTextColor(hSO, 14)
										XioSetConsoleCursorPos(hSO, 4*pxe+2, 1+2*pye)
										XioWriteConsole(hSO, CHR$ (249))
										CellStatus[pxe, pye] = 1
										Beep(400, 5)
										Sleep(100)
									ELSE
										EXIT DO
									END IF  
								END IF 
							LOOP UNTIL pye < 0
							
						CASE ELSE 	'number
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 10, 1, x, 19)
							NEXT 
							
							XioSetTextColor(hSO, 8+Cell[px, py])
							XioWriteConsole(hSO, FORMAT$ ("#", Cell[px, py]))
							CellStatus[px, py] = 1
							Skor = Skor + 10*Cell[px, py]
							
							FOR i = 1000 TO 1500 STEP 50
								Beep(i, 1)
							NEXT
							FOR i = 1000 TO 1500 STEP 30
								Beep(i, 1)
							NEXT
							FOR i = 1500 TO 1250 STEP -50
								Beep(i, 1)
							NEXT
							
							FOR x = 66 TO 77
								PutTextAttributes(hSO, 15, 1, x, 19)
							NEXT 
							
							
					END SELECT 
					
				CASE 13 'ENTER
					IF Cell[px, py] = -1 THEN 
						FOR x = 66 TO 77
								PutTextAttributes(hSO, 10, 1, x, 19)
						NEXT 
							
						XioSetTextColor(hSO, 12)
						XioSetConsoleCursorPos(hSO, 4*px+2, 1+2*py)
						XioWriteConsole(hSO, CHR$ (1))
						CellStatus[px, py] = 1
						Skor = Skor + 25
						
						FOR i = 1000 TO 1500 STEP 50
							Beep(i, 1)
						NEXT
						FOR i = 1000 TO 1500 STEP 30
							Beep(i, 1)
						NEXT
						FOR i = 1500 TO 1250 STEP -50
							Beep(i, 1)
						NEXT
							
						FOR x = 66 TO 77
							PutTextAttributes(hSO, 15, 1, x, 19)
						NEXT 
					ELSE
						FOR x = 66 TO 77
								PutTextAttributes(hSO, 10, 1, x, 19)
						NEXT 
						
						GOSUB PrintCell
						DO
							Beep(500, 500)
							Beep(800, 500)
						LOOP WHILE XioInkey() = 0
						GOSUB InitCell
						GOSUB PrintClosedCell
						FOR x = 66 TO 77
								PutTextAttributes(hSO, 15, 1, x, 19)
						NEXT 
					END IF 
			END SELECT 
		LOOP UNTIL KEY = 27
	END SUB 
	
	
	'*********************************
	'Program is beginning from here...
	'*********************************
	GOSUB InitProgram
	GOSUB InitCell
	GOSUB PrintClosedCell
	GOSUB Playing
	GOSUB ExitProgram

END FUNCTION


'**********************************************************************
'Fungsi PutTextAttributes sebagai pengganti XioPutConsoleTextAttributes
'**********************************************************************
FUNCTION PutTextAttributes (hStdOut, attribute, length, x, y)
	writeCoord = MAKELONG (x, y)
	IFZ WriteConsoleOutputAttribute (hStdOut, &attribute, length, writeCoord, &attrsWritten) THEN GOSUB Error

	' ***** Error *****
	SUB Error
		errno = GetLastError ()
		XstSystemErrorToError (errno, @error)
		lastErr = ERROR (error)
		RETURN ($$TRUE)
	END SUB

END FUNCTION
END PROGRAM

