'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Use webbrowser COM control.
'
VERSION	"0.0001"
'
'	IMPORT  "xst_s.lib"
'	IMPORT  "xsx_s.lib"
'	IMPORT  "xio_s.lib"
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT	"ole32"
	IMPORT  "shell32"   ' shell32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT	"comdlg32"  ' comdlg32.dll	    : common dialog library
'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library

DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)

DECLARE FUNCTION IWebBrowser2_QueryInterface (lpIUnknown, riid, ppvObj)
DECLARE FUNCTION IWebBrowser2_AddRef (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_Release (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_GetTypeInfoCount (lpIUnknown, pctinfo)
DECLARE FUNCTION IWebBrowser2_GetTypeInfo (lpIUnknown, iTInfo, lcid, ppTInfo)
DECLARE FUNCTION IWebBrowser2_GetIDsOfNames (lpIUnknown, riid, rgszNames, cNames, lcid, rgDispId)
DECLARE FUNCTION IWebBrowser2_Invoke (lpIUnknown, dispIdMember, riid, lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr)
DECLARE FUNCTION IWebBrowser2_GoBack (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_GoForward (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_GoHome (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_GoSearch (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_Navigate (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)
DECLARE FUNCTION IWebBrowser2_Refresh (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_Refresh2 (lpIUnknown, Level)
DECLARE FUNCTION IWebBrowser2_Stop (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_get_Application (lpIUnknown, ppDisp)
DECLARE FUNCTION IWebBrowser2_get_Parent (lpIUnknown, ppDisp)
DECLARE FUNCTION IWebBrowser2_get_Container (lpIUnknown, ppDisp)
DECLARE FUNCTION IWebBrowser2_get_Document (lpIUnknown, ppDisp)
DECLARE FUNCTION IWebBrowser2_get_TopLevelContainer (lpIUnknown, pBool)
DECLARE FUNCTION IWebBrowser2_get_Type (lpIUnknown, Type)
DECLARE FUNCTION IWebBrowser2_get_Left (lpIUnknown, pl)
DECLARE FUNCTION IWebBrowser2_put_Left (lpIUnknown, Left)
DECLARE FUNCTION IWebBrowser2_get_Top (lpIUnknown, pl)
DECLARE FUNCTION IWebBrowser2_put_Top (lpIUnknown, Top)
DECLARE FUNCTION IWebBrowser2_get_Width (lpIUnknown, pl)
DECLARE FUNCTION IWebBrowser2_put_Width (lpIUnknown, Width)
DECLARE FUNCTION IWebBrowser2_get_Height (lpIUnknown, pl)
DECLARE FUNCTION IWebBrowser2_put_Height (lpIUnknown, Height)
DECLARE FUNCTION IWebBrowser2_get_LocationName (lpIUnknown, LocationName)
DECLARE FUNCTION IWebBrowser2_get_LocationURL (lpIUnknown, LocationURL)
DECLARE FUNCTION IWebBrowser2_get_Busy (lpIUnknown, pBool)
DECLARE FUNCTION IWebBrowser2_Quit (lpIUnknown)
DECLARE FUNCTION IWebBrowser2_ClientToWindow (lpIUnknown, pcx, pcy)
DECLARE FUNCTION IWebBrowser2_PutProperty (lpIUnknown, Property, vtValue)
DECLARE FUNCTION IWebBrowser2_GetProperty (lpIUnknown, Property, pvtValue)
DECLARE FUNCTION IWebBrowser2_get_Name (lpIUnknown, Name)
DECLARE FUNCTION IWebBrowser2_get_HWND (lpIUnknown, pHWND)
DECLARE FUNCTION IWebBrowser2_get_FullName (lpIUnknown, FullName)
DECLARE FUNCTION IWebBrowser2_get_Path (lpIUnknown, Path)
DECLARE FUNCTION IWebBrowser2_get_Visible (lpIUnknown, pBool)
DECLARE FUNCTION IWebBrowser2_put_Visible (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_get_StatusBar (lpIUnknown, pBool)
DECLARE FUNCTION IWebBrowser2_put_StatusBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_get_StatusText (lpIUnknown, StatusText)
DECLARE FUNCTION IWebBrowser2_put_StatusText (lpIUnknown, StatusText)
DECLARE FUNCTION IWebBrowser2_get_ToolBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_put_ToolBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_get_MenuBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_put_MenuBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_get_FullScreen (lpIUnknown, pbFullScreen)
DECLARE FUNCTION IWebBrowser2_put_FullScreen (lpIUnknown, bFullScreen)
DECLARE FUNCTION IWebBrowser2_Navigate2 (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)
DECLARE FUNCTION IWebBrowser2_QueryStatusWB (lpIUnknown, PcmdID, pcmdf)
DECLARE FUNCTION IWebBrowser2_ExecWB (lpIUnknown, cmdID, cmdexecopt, pvaIn, pvaOut)
DECLARE FUNCTION IWebBrowser2_ShowBrowserBar (lpIUnknown, pvaClsid, pvarShow, pvarSize)
DECLARE FUNCTION IWebBrowser2_get_ReadyState (lpIUnknown, plReadyState)
DECLARE FUNCTION IWebBrowser2_get_Offline (lpIUnknown, pbOffline)
DECLARE FUNCTION IWebBrowser2_put_Offline (lpIUnknown, bOffline)
DECLARE FUNCTION IWebBrowser2_get_Silent (lpIUnknown, pbSilent)
DECLARE FUNCTION IWebBrowser2_put_Silent (lpIUnknown, bSilent)
DECLARE FUNCTION IWebBrowser2_get_RegisterAsBrowser (lpIUnknown, pbRegister)
DECLARE FUNCTION IWebBrowser2_put_RegisterAsBrowser (lpIUnknown, bRegister)
DECLARE FUNCTION IWebBrowser2_get_RegisterAsDropTarget (lpIUnknown, pbRegister)
DECLARE FUNCTION IWebBrowser2_put_RegisterAsDropTarget (lpIUnknown, bRegister)
DECLARE FUNCTION IWebBrowser2_get_TheaterMode (lpIUnknown, pbRegister)
DECLARE FUNCTION IWebBrowser2_put_TheaterMode (lpIUnknown, bRegister)
DECLARE FUNCTION IWebBrowser2_get_AddressBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_put_AddressBar (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_get_Resizable (lpIUnknown, Value)
DECLARE FUNCTION IWebBrowser2_put_Resizable (lpIUnknown, Value)

$$ID_BROWSER = 100

'D30C1661-CDAF-11d0-8A3E-00C04FC9E26E
$$IID_IWebBrowser2$ = "\x61\x16\x0C\xD3\xAF\xCD\xd0\x11\x8A\x3E\x00\xC0\x4F\xC9\xE2\x6E"
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

	XioCreateConsole (title$, 50)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect
	GUID riid
	VARIANT var
	
	VARIANT_BOOL VARIANT_TRUE, VARIANT_FALSE
	
	VARIANT_TRUE = -1
	VARIANT_FALSE = 0

	SELECT CASE msg

		CASE $$WM_CREATE :
			DIM args[]
			XstCall ("AtlAxWinInit", "atl.dll", @args[])
			GetClientRect (hWnd, &rect)
			hBrowser = CreateWindowExA (0, &"AtlAxWin", &"https://sites.google.com/view/xblite/home", $$WS_CHILD | $$WS_VISIBLE | $$WS_VSCROLL | $$WS_HSCROLL, 0, 0, rect.right, rect.bottom, hWnd, $$ID_BROWSER, GetModuleHandleA(NULL), NULL)
			PRINT "hBrowser="; hBrowser
			DIM args[1]
			args[0] = hBrowser
			pUnk = 0
			args[1] = &pUnk
			XstCall ("AtlAxGetControl", "atl.dll", @args[]) 
			PRINT "Create AtlAxWin done...pUnk="; pUnk
			IFZ pUnk THEN RETURN
			
			XLONGAT(&&riid) = &$$IID_IWebBrowser2$
			
			hr = IWebBrowser2_QueryInterface (pUnk, &riid, &pIweb)
			PRINT "pIweb = "; pIweb, " hr="; hr
			IWebBrowser2_Release (pUnk)
			IF hr < 0 THEN RETURN
			
			' navigate to new url
			url$ = "https://sites.google.com/view/xblite/home"				' url string
			uniurl$ = XstAnsiToUnicode$ (url$)		' convert to unicode (bstr)
			var.vt = $$VT_BSTR										' set variant type to $$VT_BSTR
			var.bstrVal = &uniurl$								' set bstr value to address of unicode string
			hr = IWebBrowser2_Navigate2 (pIweb, &var, NULL, NULL, NULL, NULL)		' navigate to new url
			PRINT "Navigate2 hr="; hr


		CASE $$WM_SIZE :
			h = GetDlgItem (hWnd, $$ID_BROWSER)
			cx = LOWORD(lParam)
			cy = HIWORD(lParam)
      SetWindowPos (h, NULL, 0, 0, cx, cy, $$SWP_NOZORDER)
			

'		CASE $$WM_COMMAND :
'			id         = LOWORD(wParam)
'			hwndCtl    = lParam
'			notifyCode = HIWORD(wParam)
'			SELECT CASE id
'			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage(0)

'		CASE $$WM_NOTIFY :
'			idCtrl = wParam
'			SELECT CASE idCtrl
'				CASE $$ListView1 :
'					GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)
'					SELECT CASE code :
'					END SELECT
'			END SELECT

'		CASE $$WM_PAINT :
'			hdc = BeginPaint (hWnd, &ps)
'			EndPaint (hWnd, &ps)

'		CASE $$WM_SIZE :
'			w = LOWORD (lParam)
'			h = HIWORD (lParam)
'			sizeType = wParam

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	INITCOMMONCONTROLSEX icc
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
	' initialize the common control classes
  icc.dwSize = SIZE(icc)
  icc.dwICC  = $$ICC_ANIMATE_CLASS      OR _
               $$ICC_BAR_CLASSES        OR _
               $$ICC_COOL_CLASSES       OR _
               $$ICC_DATE_CLASSES       OR _
               $$ICC_HOTKEY_CLASS       OR _
               $$ICC_INTERNET_CLASSES   OR _
               $$ICC_LISTVIEW_CLASSES   OR _
               $$ICC_NATIVEFNTCTL_CLASS OR _
               $$ICC_PAGESCROLLER_CLASS OR _
               $$ICC_PROGRESS_CLASS     OR _
               $$ICC_TAB_CLASSES        OR _
               $$ICC_TREEVIEW_CLASSES   OR _
               $$ICC_UPDOWN_CLASS       OR _
               $$ICC_USEREX_CLASSES     OR _
               $$ICC_WIN95_CLASSES
  InitCommonControlsEx (&icc)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "AtlAxWin Control"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 800
	h 					= 600
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR(className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF
	
	IFZ icon$ THEN icon$ = "scrabble"
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION

FUNCTION IWebBrowser2_QueryInterface (lpIUnknown, riid, ppvObj)

	FUNCADDR QueryInterface (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	QueryInterface = XLONGAT (vtblAddr)
	IFZ QueryInterface THEN RETURN ($$TRUE)

	RETURN @QueryInterface (lpIUnknown, riid, ppvObj)

END FUNCTION

FUNCTION IWebBrowser2_AddRef (lpIUnknown)

	FUNCADDR AddRef (XLONG)

	vtblAddr	= XLONGAT (lpIUnknown)
	AddRef		= XLONGAT (vtblAddr + 0x04)
	IFZ AddRef THEN RETURN ($$TRUE)

	RETURN @AddRef (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_Release (lpIUnknown)

	FUNCADDR Release (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Release	= XLONGAT (vtblAddr + 0x08)
	IFZ Release THEN RETURN ($$TRUE)

	RETURN @Release (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_GetTypeInfoCount (lpIUnknown, pctinfo)

	FUNCADDR GetTypeInfoCount (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetTypeInfoCount	= XLONGAT (vtblAddr + 0x0C)
	IFZ GetTypeInfoCount THEN RETURN ($$TRUE)

	RETURN @GetTypeInfoCount (lpIUnknown, pctinfo)

END FUNCTION

FUNCTION IWebBrowser2_GetTypeInfo (lpIUnknown, iTInfo, lcid, ppTInfo)

	FUNCADDR GetTypeInfo (XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetTypeInfo	= XLONGAT (vtblAddr + 0x10)
	IFZ GetTypeInfo THEN RETURN ($$TRUE)

	RETURN @GetTypeInfo (lpIUnknown, iTInfo, lcid, ppTInfo)

END FUNCTION

FUNCTION IWebBrowser2_GetIDsOfNames (lpIUnknown, riid, rgszNames, cNames, lcid, rgDispId)

	FUNCADDR GetIDsOfNames (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GetIDsOfNames	= XLONGAT (vtblAddr + 0x14)
	IFZ GetIDsOfNames THEN RETURN ($$TRUE)

	RETURN @GetIDsOfNames (lpIUnknown, riid, rgszNames, cNames, lcid, rgDispId)

END FUNCTION

FUNCTION IWebBrowser2_Invoke (lpIUnknown, dispIdMember, riid, lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr)

	FUNCADDR Invoke (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Invoke	= XLONGAT (vtblAddr + 0x18)
	IFZ Invoke THEN RETURN ($$TRUE)

	RETURN @Invoke (lpIUnknown, dispIdMember, riid, lcid, wFlags, pDispParams, pVarResult, pExcepInfo, puArgErr)

END FUNCTION

FUNCTION IWebBrowser2_GoBack (lpIUnknown)

	FUNCADDR GoBack (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GoBack	= XLONGAT (vtblAddr + 0x1C)
	IFZ GoBack THEN RETURN ($$TRUE)

	RETURN @GoBack (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_GoForward (lpIUnknown)

	FUNCADDR GoForward (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GoForward	= XLONGAT (vtblAddr + 0x20)
	IFZ GoForward THEN RETURN ($$TRUE)

	RETURN @GoForward (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_GoHome (lpIUnknown)

	FUNCADDR GoHome (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GoHome	= XLONGAT (vtblAddr + 0x24)
	IFZ GoHome THEN RETURN ($$TRUE)

	RETURN @GoHome (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_GoSearch (lpIUnknown)

	FUNCADDR GoSearch (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	GoSearch	= XLONGAT (vtblAddr + 0x28)
	IFZ GoSearch THEN RETURN ($$TRUE)

	RETURN @GoSearch (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_Navigate (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)

	FUNCADDR Navigate (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Navigate	= XLONGAT (vtblAddr + 0x2C)
	IFZ Navigate THEN RETURN ($$TRUE)

	RETURN @Navigate (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)

END FUNCTION

FUNCTION IWebBrowser2_Refresh (lpIUnknown)

	FUNCADDR Refresh (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Refresh	= XLONGAT (vtblAddr + 0x30)
	IFZ Refresh THEN RETURN ($$TRUE)

	RETURN @Refresh (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_Refresh2 (lpIUnknown, Level)

	FUNCADDR Refresh2 (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Refresh2	= XLONGAT (vtblAddr + 0x34)
	IFZ Refresh2 THEN RETURN ($$TRUE)

	RETURN @Refresh2 (lpIUnknown, Level)

END FUNCTION

FUNCTION IWebBrowser2_Stop (lpIUnknown)

	FUNCADDR Stop (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Stop	= XLONGAT (vtblAddr + 0x38)
	IFZ Stop THEN RETURN ($$TRUE)

	RETURN @Stop (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_get_Application (lpIUnknown, ppDisp)

	FUNCADDR get_Application (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Application	= XLONGAT (vtblAddr + 0x3C)
	IFZ get_Application THEN RETURN ($$TRUE)

	RETURN @get_Application (lpIUnknown, ppDisp)

END FUNCTION

FUNCTION IWebBrowser2_get_Parent (lpIUnknown, ppDisp)

	FUNCADDR get_Parent (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Parent	= XLONGAT (vtblAddr + 0x40)
	IFZ get_Parent THEN RETURN ($$TRUE)

	RETURN @get_Parent (lpIUnknown, ppDisp)

END FUNCTION

FUNCTION IWebBrowser2_get_Container (lpIUnknown, ppDisp)

	FUNCADDR get_Container (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Container	= XLONGAT (vtblAddr + 0x44)
	IFZ get_Container THEN RETURN ($$TRUE)

	RETURN @get_Container (lpIUnknown, ppDisp)

END FUNCTION

FUNCTION IWebBrowser2_get_Document (lpIUnknown, ppDisp)

	FUNCADDR get_Document (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Document	= XLONGAT (vtblAddr + 0x48)
	IFZ get_Document THEN RETURN ($$TRUE)

	RETURN @get_Document (lpIUnknown, ppDisp)

END FUNCTION

FUNCTION IWebBrowser2_get_TopLevelContainer (lpIUnknown, pBool)

	FUNCADDR get_TopLevelContainer (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_TopLevelContainer	= XLONGAT (vtblAddr + 0x4C)
	IFZ get_TopLevelContainer THEN RETURN ($$TRUE)

	RETURN @get_TopLevelContainer (lpIUnknown, pBool)

END FUNCTION

FUNCTION IWebBrowser2_get_Type (lpIUnknown, Type)

	FUNCADDR get_Type (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Type	= XLONGAT (vtblAddr + 0x50)
	IFZ get_Type THEN RETURN ($$TRUE)

	RETURN @get_Type (lpIUnknown, Type)

END FUNCTION

FUNCTION IWebBrowser2_get_Left (lpIUnknown, pl)

	FUNCADDR get_Left (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Left	= XLONGAT (vtblAddr + 0x54)
	IFZ get_Left THEN RETURN ($$TRUE)

	RETURN @get_Left (lpIUnknown, pl)

END FUNCTION

FUNCTION IWebBrowser2_put_Left (lpIUnknown, Left)

	FUNCADDR put_Left (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Left	= XLONGAT (vtblAddr + 0x58)
	IFZ put_Left THEN RETURN ($$TRUE)

	RETURN @put_Left (lpIUnknown, Left)

END FUNCTION

FUNCTION IWebBrowser2_get_Top (lpIUnknown, pl)

	FUNCADDR get_Top (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Top	= XLONGAT (vtblAddr + 0x5C)
	IFZ get_Top THEN RETURN ($$TRUE)

	RETURN @get_Top (lpIUnknown, pl)

END FUNCTION

FUNCTION IWebBrowser2_put_Top (lpIUnknown, Top)

	FUNCADDR put_Top (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Top	= XLONGAT (vtblAddr + 0x60)
	IFZ put_Top THEN RETURN ($$TRUE)

	RETURN @put_Top (lpIUnknown, Top)

END FUNCTION

FUNCTION IWebBrowser2_get_Width (lpIUnknown, pl)

	FUNCADDR get_Width (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Width	= XLONGAT (vtblAddr + 0x64)
	IFZ get_Width THEN RETURN ($$TRUE)

	RETURN @get_Width (lpIUnknown, pl)

END FUNCTION

FUNCTION IWebBrowser2_put_Width (lpIUnknown, Width)

	FUNCADDR put_Width (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Width	= XLONGAT (vtblAddr + 0x68)
	IFZ put_Width THEN RETURN ($$TRUE)

	RETURN @put_Width (lpIUnknown, Width)

END FUNCTION

FUNCTION IWebBrowser2_get_Height (lpIUnknown, pl)

	FUNCADDR get_Height (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Height	= XLONGAT (vtblAddr + 0x6C)
	IFZ get_Height THEN RETURN ($$TRUE)

	RETURN @get_Height (lpIUnknown, pl)

END FUNCTION

FUNCTION IWebBrowser2_put_Height (lpIUnknown, Height)

	FUNCADDR put_Height (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Height	= XLONGAT (vtblAddr + 0x70)
	IFZ put_Height THEN RETURN ($$TRUE)

	RETURN @put_Height (lpIUnknown, Height)

END FUNCTION

FUNCTION IWebBrowser2_get_LocationName (lpIUnknown, LocationName)

	FUNCADDR get_LocationName (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_LocationName	= XLONGAT (vtblAddr + 0x74)
	IFZ get_LocationName THEN RETURN ($$TRUE)

	RETURN @get_LocationName (lpIUnknown, LocationName)

END FUNCTION

FUNCTION IWebBrowser2_get_LocationURL (lpIUnknown, LocationURL)

	FUNCADDR get_LocationURL (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_LocationURL	= XLONGAT (vtblAddr + 0x78)
	IFZ get_LocationURL THEN RETURN ($$TRUE)

	RETURN @get_LocationURL (lpIUnknown, LocationURL)

END FUNCTION

FUNCTION IWebBrowser2_get_Busy (lpIUnknown, pBool)

	FUNCADDR get_Busy (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Busy	= XLONGAT (vtblAddr + 0x7C)
	IFZ get_Busy THEN RETURN ($$TRUE)

	RETURN @get_Busy (lpIUnknown, pBool)

END FUNCTION

FUNCTION IWebBrowser2_Quit (lpIUnknown)

	FUNCADDR Quit (XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Quit	= XLONGAT (vtblAddr + 0x80)
	IFZ Quit THEN RETURN ($$TRUE)

	RETURN @Quit (lpIUnknown)

END FUNCTION

FUNCTION IWebBrowser2_ClientToWindow (lpIUnknown, pcx, pcy)

	FUNCADDR ClientToWindow (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	ClientToWindow = XLONGAT (vtblAddr + 0x84)
	IFZ ClientToWindow THEN RETURN ($$TRUE)

	RETURN @ClientToWindow (lpIUnknown, pcx, pcy)

END FUNCTION

FUNCTION IWebBrowser2_PutProperty (lpIUnknown, Property, vtValue)

	FUNCADDR PutProperty (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	PutProperty = XLONGAT (vtblAddr + 0x88)
	IFZ PutProperty THEN RETURN ($$TRUE)

	RETURN @PutProperty (lpIUnknown, Property, vtValue)

END FUNCTION

FUNCTION IWebBrowser2_GetProperty (lpIUnknown, Property, pvtValue)

	FUNCADDR GetProperty (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	GetProperty = XLONGAT (vtblAddr + 0x8C)
	IFZ GetProperty THEN RETURN ($$TRUE)

	RETURN @GetProperty (lpIUnknown, Property, pvtValue)

END FUNCTION

FUNCTION IWebBrowser2_get_Name (lpIUnknown, Name)

	FUNCADDR get_Name (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Name	= XLONGAT (vtblAddr + 0x90)
	IFZ get_Name THEN RETURN ($$TRUE)

	RETURN @get_Name (lpIUnknown, Name)

END FUNCTION

FUNCTION IWebBrowser2_get_HWND (lpIUnknown, pHWND)

	FUNCADDR get_HWND (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_HWND	= XLONGAT (vtblAddr + 0x94)
	IFZ get_HWND THEN RETURN ($$TRUE)

	RETURN @get_HWND (lpIUnknown, pHWND)

END FUNCTION

FUNCTION IWebBrowser2_get_FullName (lpIUnknown, FullName)

	FUNCADDR get_FullName (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_FullName	= XLONGAT (vtblAddr + 0x98)
	IFZ get_FullName THEN RETURN ($$TRUE)

	RETURN @get_FullName (lpIUnknown, FullName)

END FUNCTION

FUNCTION IWebBrowser2_get_Path (lpIUnknown, Path)

	FUNCADDR get_Path (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Path	= XLONGAT (vtblAddr + 0x9C)
	IFZ get_Path THEN RETURN ($$TRUE)

	RETURN @get_Path (lpIUnknown, Path)

END FUNCTION

FUNCTION IWebBrowser2_get_Visible (lpIUnknown, pBool)

	FUNCADDR get_Visible (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Visible	= XLONGAT (vtblAddr + 0xA0)
	IFZ get_Visible THEN RETURN ($$TRUE)

	RETURN @get_Visible (lpIUnknown, pBool)

END FUNCTION

FUNCTION IWebBrowser2_put_Visible (lpIUnknown, Value)

	FUNCADDR put_Visible (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Visible	= XLONGAT (vtblAddr + 0xA4)
	IFZ put_Visible THEN RETURN ($$TRUE)

	RETURN @put_Visible (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_get_StatusBar (lpIUnknown, pBool)

	FUNCADDR get_StatusBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_StatusBar	= XLONGAT (vtblAddr + 0xA8)
	IFZ get_StatusBar THEN RETURN ($$TRUE)

	RETURN @get_StatusBar (lpIUnknown, pBool)

END FUNCTION

FUNCTION IWebBrowser2_put_StatusBar (lpIUnknown, Value)

	FUNCADDR put_StatusBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_StatusBar	= XLONGAT (vtblAddr + 0xAC)
	IFZ put_StatusBar THEN RETURN ($$TRUE)

	RETURN @put_StatusBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_get_StatusText (lpIUnknown, StatusText)

	FUNCADDR get_StatusText (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_StatusText	= XLONGAT (vtblAddr + 0xB0)
	IFZ get_StatusText THEN RETURN ($$TRUE)

	RETURN @get_StatusText (lpIUnknown, StatusText)

END FUNCTION

FUNCTION IWebBrowser2_put_StatusText (lpIUnknown, StatusText)

	FUNCADDR put_StatusText (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_StatusText	= XLONGAT (vtblAddr + 0xB4)
	IFZ put_StatusText THEN RETURN ($$TRUE)

	RETURN @put_StatusText (lpIUnknown, StatusText)

END FUNCTION

FUNCTION IWebBrowser2_get_ToolBar (lpIUnknown, Value)

	FUNCADDR get_ToolBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_ToolBar	= XLONGAT (vtblAddr + 0xB8)
	IFZ get_ToolBar THEN RETURN ($$TRUE)

	RETURN @get_ToolBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_put_ToolBar (lpIUnknown, Value)

	FUNCADDR put_ToolBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_ToolBar	= XLONGAT (vtblAddr + 0xBC)
	IFZ put_ToolBar THEN RETURN ($$TRUE)

	RETURN @put_ToolBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_get_MenuBar (lpIUnknown, Value)

	FUNCADDR get_MenuBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_MenuBar	= XLONGAT (vtblAddr + 0xC0)
	IFZ get_MenuBar THEN RETURN ($$TRUE)

	RETURN @get_MenuBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_put_MenuBar (lpIUnknown, Value)

	FUNCADDR put_MenuBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_MenuBar	= XLONGAT (vtblAddr + 0xC4)
	IFZ put_MenuBar THEN RETURN ($$TRUE)

	RETURN @put_MenuBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_get_FullScreen (lpIUnknown, pbFullScreen)

	FUNCADDR get_FullScreen (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_FullScreen	= XLONGAT (vtblAddr + 0xC8)
	IFZ get_FullScreen THEN RETURN ($$TRUE)

	RETURN @get_FullScreen (lpIUnknown, pbFullScreen)

END FUNCTION

FUNCTION IWebBrowser2_put_FullScreen (lpIUnknown, bFullScreen)

	FUNCADDR put_FullScreen (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_FullScreen	= XLONGAT (vtblAddr + 0xCC)
	IFZ put_FullScreen THEN RETURN ($$TRUE)

	RETURN @put_FullScreen (lpIUnknown, bFullScreen)

END FUNCTION

FUNCTION IWebBrowser2_Navigate2 (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)

	FUNCADDR Navigate2 (XLONG, XLONG, XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	Navigate2	= XLONGAT (vtblAddr + 0xD0)
	IFZ Navigate2 THEN RETURN ($$TRUE)

	RETURN @Navigate2 (lpIUnknown, URL, Flags, TargetFrameName, PostData, Headers)

END FUNCTION

FUNCTION IWebBrowser2_QueryStatusWB (lpIUnknown, cmdID, pcmdf)

	FUNCADDR QueryStatusWB (XLONG, XLONG, XLONG)

	vtblAddr       = XLONGAT (lpIUnknown)
	QueryStatusWB = XLONGAT (vtblAddr + 0xD4)
	IFZ QueryStatusWB THEN RETURN ($$TRUE)

	RETURN @QueryStatusWB (lpIUnknown, cmdID, pcmdf)

END FUNCTION

FUNCTION IWebBrowser2_ExecWB (lpIUnknown, cmdID, cmdexecopt, pvaIn, pvaOut)

	FUNCADDR ExecWB (XLONG, XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	ExecWB	= XLONGAT (vtblAddr + 0xD8)
	IFZ ExecWB THEN RETURN ($$TRUE)

	RETURN @ExecWB (lpIUnknown, cmdID, cmdexecopt, pvaIn, pvaOut)

END FUNCTION

FUNCTION IWebBrowser2_ShowBrowserBar (lpIUnknown, pvaClsid, pvarShow, pvarSize)

	FUNCADDR ShowBrowserBar (XLONG, XLONG, XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	ShowBrowserBar	= XLONGAT (vtblAddr + 0xDC)
	IFZ ShowBrowserBar THEN RETURN ($$TRUE)

	RETURN @ShowBrowserBar (lpIUnknown, pvaClsid, pvarShow, pvarSize)

END FUNCTION

FUNCTION IWebBrowser2_get_ReadyState (lpIUnknown, plReadyState)

	FUNCADDR get_ReadyState (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_ReadyState	= XLONGAT (vtblAddr + 0xE0)
	IFZ get_ReadyState THEN RETURN ($$TRUE)

	RETURN @get_ReadyState (lpIUnknown, plReadyState)

END FUNCTION

FUNCTION IWebBrowser2_get_Offline (lpIUnknown, pbOffline)

	FUNCADDR get_Offline (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Offline	= XLONGAT (vtblAddr + 0xE4)
	IFZ get_Offline THEN RETURN ($$TRUE)

	RETURN @get_Offline (lpIUnknown, pbOffline)

END FUNCTION

FUNCTION IWebBrowser2_put_Offline (lpIUnknown, bOffline)

	FUNCADDR put_Offline (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Offline	= XLONGAT (vtblAddr + 0xE8)
	IFZ put_Offline THEN RETURN ($$TRUE)

	RETURN @put_Offline (lpIUnknown, bOffline)

END FUNCTION

FUNCTION IWebBrowser2_get_Silent (lpIUnknown, pbSilent)

	FUNCADDR get_Silent (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Silent	= XLONGAT (vtblAddr + 0xEC)
	IFZ get_Silent THEN RETURN ($$TRUE)

	RETURN @get_Silent (lpIUnknown, pbSilent)

END FUNCTION

FUNCTION IWebBrowser2_put_Silent (lpIUnknown, bSilent)

	FUNCADDR put_Silent (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Silent	= XLONGAT (vtblAddr + 0xF0)
	IFZ put_Silent THEN RETURN ($$TRUE)

	RETURN @put_Silent (lpIUnknown, bSilent)

END FUNCTION

FUNCTION IWebBrowser2_get_RegisterAsBrowser (lpIUnknown, pbRegister)

	FUNCADDR get_RegisterAsBrowser (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_RegisterAsBrowser	= XLONGAT (vtblAddr + 0xF4)
	IFZ get_RegisterAsBrowser THEN RETURN ($$TRUE)

	RETURN @get_RegisterAsBrowser (lpIUnknown, pbRegister)

END FUNCTION

FUNCTION IWebBrowser2_put_RegisterAsBrowser (lpIUnknown, bRegister)

	FUNCADDR put_RegisterAsBrowser (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_RegisterAsBrowser	= XLONGAT (vtblAddr + 0xF8)
	IFZ put_RegisterAsBrowser THEN RETURN ($$TRUE)

	RETURN @put_RegisterAsBrowser (lpIUnknown, bRegister)

END FUNCTION

FUNCTION IWebBrowser2_get_RegisterAsDropTarget (lpIUnknown, pbRegister)

	FUNCADDR get_RegisterAsDropTarget (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_RegisterAsDropTarget	= XLONGAT (vtblAddr + 0xFC)
	IFZ get_RegisterAsDropTarget THEN RETURN ($$TRUE)

	RETURN @get_RegisterAsDropTarget (lpIUnknown, pbRegister)

END FUNCTION

FUNCTION IWebBrowser2_put_RegisterAsDropTarget (lpIUnknown, bRegister)

	FUNCADDR put_RegisterAsDropTarget (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_RegisterAsDropTarget	= XLONGAT (vtblAddr + 0x100)
	IFZ put_RegisterAsDropTarget THEN RETURN ($$TRUE)

	RETURN @put_RegisterAsDropTarget (lpIUnknown, bRegister)

END FUNCTION

FUNCTION IWebBrowser2_get_TheaterMode (lpIUnknown, pbRegister)

	FUNCADDR get_TheaterMode (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_TheaterMode	= XLONGAT (vtblAddr + 0x104)
	IFZ get_TheaterMode THEN RETURN ($$TRUE)

	RETURN @get_TheaterMode (lpIUnknown, pbRegister)

END FUNCTION

FUNCTION IWebBrowser2_put_TheaterMode (lpIUnknown, bRegister)

	FUNCADDR put_TheaterMode (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_TheaterMode	= XLONGAT (vtblAddr + 0x108)
	IFZ put_TheaterMode THEN RETURN ($$TRUE)

	RETURN @put_TheaterMode (lpIUnknown, bRegister)

END FUNCTION

FUNCTION IWebBrowser2_get_AddressBar (lpIUnknown, Value)

	FUNCADDR get_AddressBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_AddressBar	= XLONGAT (vtblAddr + 0x10C)
	IFZ get_AddressBar THEN RETURN ($$TRUE)

	RETURN @get_AddressBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_put_AddressBar (lpIUnknown, Value)

	FUNCADDR put_AddressBar (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_AddressBar	= XLONGAT (vtblAddr + 0x110)
	IFZ put_AddressBar THEN RETURN ($$TRUE)

	RETURN @put_AddressBar (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_get_Resizable (lpIUnknown, Value)

	FUNCADDR get_Resizable (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	get_Resizable	= XLONGAT (vtblAddr + 0x114)
	IFZ get_Resizable THEN RETURN ($$TRUE)

	RETURN @get_Resizable (lpIUnknown, Value)

END FUNCTION

FUNCTION IWebBrowser2_put_Resizable (lpIUnknown, Value)

	FUNCADDR put_Resizable (XLONG, XLONG)

	vtblAddr = XLONGAT (lpIUnknown)
	put_Resizable	= XLONGAT (vtblAddr + 0x118)
	IFZ put_Resizable THEN RETURN ($$TRUE)

	RETURN @put_Resizable (lpIUnknown, Value)

END FUNCTION
END PROGRAM
