'
' ####################
' #####  PROLOG  #####
' ####################
'
' Compare precision of double vs longdouble math functions
'
VERSION "0.0001"
CONSOLE

	IMPORT "xst"				' Standard library : required by most programs
'	IMPORT "xsx"				' Extended standard library
'	IMPORT "xio"				' Console input/ouput LIBRARY

	IMPORT "xma"
	IMPORT "xml"

DECLARE FUNCTION Entry ()

FUNCTION Entry ()

DOUBLE value, error
LONGDOUBLE valueL, errorL

' double values
  value = 1.0
	FOR i=1  TO 10
		 FOR j=1 TO 1000
				FOR k=1 TO 1000
					 value = Tan(Atan(Exp(Log(Sqrt(value * value)))))+1.0#
				NEXT k
		 NEXT j
	NEXT i
	PRINT "double value  "; STRING$(value)
	error = (1.0# - value/1.e7#) * 100.0#
	PRINT "double error  "; STRING$(error)


' longdouble values
  valueL = 1.0
	FOR i=1  TO 10
		 FOR j=1 TO 1000
				FOR k=1 TO 1000
					 valueL = TanL(AtanL(ExpL(LogL(SqrtL(valueL * valueL)))))+1.0##
				NEXT k
		 NEXT j
	NEXT i
	PRINT "longdouble value  "; STRING$(valueL)
	errorL = (1.0## - valueL/1.e7##) * 100.0##
	PRINT "longdouble error  "; STRING$(errorL)

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM