'Subject: Class number of an imaginary quadratic field with
'         Dirichlet's formula. Only for small discriminants.
'Author : Sjoerd.J.Schaper
'Date   : 12-06-2004
'Code   : XBasic adaptation demo
PROGRAM	"clasimag"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()
FUNCTION VOID Main()
N = 0: D = 1: d2 = 2: p = 3: t3 = 4
k = LargeInit("clasimag")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole(): PRINT

Readnr = OPEN(WrkD$ + "\\clasimag",$$RD)

begin:
'Ni$ = INLINE$ (" abs(N)? ")
Ni$ = INFILE$ (Readnr)
IF INSTR(Ni$, "'") THEN GOTO begin
IF XLONG(LEFT$(Ni$, 5)) < 1 THEN GOTO eind
Readst(N, Ni$)
Printn(N, "   N = ", "", 1)

Letf(D, 4)
IF Cmp(N, D) < 1 THEN '               Abs(N) <= 4
   g$ = "h(D) = 1": GOTO jump
END IF
IF IsSqr(N, D) THEN
   g$ = "N is square": GOTO jump
END IF

Copyf(N, D): t = 0
Triald(p, D, 1024) '                  is N quadratfrei?
DO WHILE ExQ(D, @k, p, @t)
   IF k > 1 THEN
      g$ = "square factor found": GOTO jump
   END IF
LOOP

Copyf(N, D)
IF Mp2(N, 4) = 3 THEN '              -N mod 4 = 1
   stp = 1
ELSE
   Lsft(D, 2): stp = 2 '              D:= 4 * N
END IF

Copyf(D, d2): Rsft(d2, 1)
Sets(D, -1): Letf(p, 1)
h = 0
DO
   h = h + Kronec(D, p, t3) '         Dirichlet's class number formula
   Inc(p, stp)
LOOP UNTIL Cmp(p, d2) = 1 '           p > |D|/ 2
Printn(D, "   D = ", "", 1)
Letf(p, 2)
g$ = "h(D) =" + STR$(h / (2 - Kronec(D, p, t3)))

jump:
Prints(g$, 2)
GOTO begin

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
Term ()
END FUNCTION
END PROGRAM
