
' Note: if this program is not displaying mouse move or mouse down events,
'       then in console window, right click the window title bar and select 
'       Properties, then under Edit Options, deselect Quick Edit Mode

PROGRAM "consolemouse"
CONSOLE

IMPORT "xio"
IMPORT "xsx"
IMPORT "xst"
IMPORT "kernel32"

DECLARE FUNCTION Main()

FUNCTION Main()

	INPUT_RECORD Events[10]

	Title$ = "XConsoleMouse - By Chandra MDE"
	
	GOSUB Init
	GOSUB MousingAround
	GOSUB ExitProgram

	SUB Init
		DIM args[3]

		hSI = XioGetStdIn()
		hSO = XioGetStdOut()
		XioSetCursorType(hSO, $$NOCURSOR)
		SetConsoleTitleA(&Title$)
		XioClearConsole(hSO)
		XioSetConsoleBufferSize(hSO, 80, 25)
		PRINT "XBLite Console Mouse Demo - By Chandra MDE"
		PRINT "Press ESC to quit..."

'		args[0] = hSO
'		args[1] = 1
'		args[2] = &coord

'		XstCall("SetConsoleDisplayMode", "kernel32.dll", @args[])

	END SUB

	SUB MousingAround
		Running = 1

		DO
			NumberOfEventsRead = 0
			GetNumberOfConsoleInputEvents (hSI, &nEvents)

			IF nEvents THEN 
				REDIM Events[nEvents-1]
				FOR i = 0 TO nEvents-1
					err = ReadConsoleInputA(hSI, &Events[], nEvents, &NumberOfEventsRead)
					SELECT CASE Events[i].EventType
						CASE $$KEY_EVENT : 
							IF Events[i].KeyEvent.wVirtualKeyCode = 27 THEN Running = 0

						CASE $$MOUSE_EVENT : 
							MouseX = Events[i].MouseEvent.dwMousePosition.x
							MouseY = Events[i].MouseEvent.dwMousePosition.y
			
							Btn1 = Events[i].MouseEvent.dwButtonState AND 1
							Btn2 = Events[i].MouseEvent.dwButtonState AND 2
							Btn3 = Events[i].MouseEvent.dwButtonState AND 4
			
							IF Events[i].MouseEvent.dwEventFlags = $$DOUBLE_CLICK THEN DblClk = 1 ELSE DblClk = 0
							IF Events[i].MouseEvent.dwEventFlags = $$MOUSE_MOVED THEN MouseMoved = 1 ELSE MouseMoved = 0
			
							XioSetConsoleCursorPos(hSO, 15, 5)
							XioWriteConsole(hSO, FORMAT$ ("X = ###", MouseX) + FORMAT$ (", Y = ###", MouseY))
							XioSetConsoleCursorPos(hSO, 15, 7)
							XioWriteConsole(hSO, FORMAT$ ("LeftBtn =#,  ", Btn1) + FORMAT$ ("RightBtn =#,  ", Btn2) + FORMAT$ ("MidBtn = #", Btn3))
							XioSetConsoleCursorPos(hSO, 15, 9)
							XioWriteConsole(hSO, FORMAT$ ("Double-Clicked = #", DblClk))
							XioSetConsoleCursorPos(hSO, 15, 11)
							XioWriteConsole(hSO, FORMAT$ ("Mouse-Moved = #", MouseMoved))
					END SELECT 
				NEXT i
			END IF 
		LOOP UNTIL Running = 0
	END SUB
	
	SUB ExitProgram
	
		XioSetConsoleCursorPos(hSO, 0, 24)
		IF err$ THEN XioWriteConsole(hSO, err$)
		?
		XioWriteConsole(hSO, "Press any key...")

		DO : LOOP WHILE XioInkey() = 0

		XioCloseStdHandle(hSI)
		XioCloseStdHandle(hSO)
	END SUB


END FUNCTION
END PROGRAM
