' Use XstTry to handle exceptions
CONSOLE

IMPORT "xst"
IMPORT "xsx"
IMPORT "gdi32"
IMPORT "user32"
DECLARE FUNCTION  Entry ()

FUNCTION  Entry ()
EXCEPTION_DATA exception

	XstTry (SUBADDRESS(Try), SUBADDRESS(ExceptionHandler), @exception)

SUB Try
	? "Attempting division by 0"
  x = 1 / 0 'divide-by-zero exception
END SUB

SUB ExceptionHandler
  XstExceptionNumberToName (exception.code, @exception$)
  program$ = XstGetProgramFileName$ ()
  MessageBoxA (0, &exception$, &program$, $$MB_OK)
  exception.response = $$ExceptionTerminate

	INLINE$ ("press any key to quit")
	QUIT (0)
END SUB

END FUNCTION

END PROGRAM