' example using goxbl and gotools: golink, gorc, and goasm
' Using goxbl is automatic if compiling using -go command line switch
' I need here to import the kernel32.dec file for the SYSTEMTIME composite TYPE declaration

' Using godll and -go command switch allows calling API functions without needing their
' respective .lib files. The function is found directly from the linked dll, eg, kernel32.dll.

PROGRAM "api"
VERSION "0.0002"
CONSOLE

'IMPORT  "goxbl"
IMPORT	"kernel32.dec"	' Import kernel32.dll declarations
'
DECLARE  FUNCTION  Entry       ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

  SYSTEMTIME sysTime

' get local time
  GetLocalTime (&sysTime)

' set parameters for GetTimeFormatA
  timeStr$ = NULL$ (100)
  flags = 0
  format$ = ""
  GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
  timeStr$ = CSIZE$ (timeStr$)
  PRINT "Default local time format:", timeStr$

' use a time format string
  timeStr$ = NULL$ (100)
  flags = 0
  format$ = "hh\':\'mm\':\'ss tt"   ' use escape backslash before :
  GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
  timeStr$ = CSIZE$ (timeStr$)
  PRINT "Use time format string   :", timeStr$

' use a time format string
  timeStr$ = NULL$ (100)
  flags = 0
  format$ = "HH\'h\'mm"
  GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
  timeStr$ = CSIZE$ (timeStr$)
  PRINT "Use time format string   :", timeStr$

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM
