'Subject: Fibonacci numbers and the golden ratio phi: a simple
'         recurrent sequence. To demonstrate at which speed the internal
'         binary data is converted to decimal and output as string.
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"fibonacc"
VERSION	"00.01"
IMPORT	"bignumXB"
IMPORT	"xst"
'
DECLARE FUNCTION VOID Main()
'
FUNCTION VOID Main()
p0 = 0: p1 = 1: r = 2
k = LargeInit("fibonacc")
XstGetSystemTime(@Tim)
XstClearConsole(): PRINT

lt = 2451 '                           set length
'
Letf(p0, 0): Letf(p1, 1)
FOR t = 1 TO lt
  Add(p0, p1): Swp(p0, p1) '          F_n = F_n-2 + F_n-1
  g$ = "F" + LTRIM$(STR$(t)) + ": "
  Printn(p0, g$, "", 2)
NEXT t
Setl(r, 2 * Getl(p1) / $$L10 - 6)
Printr(p0, p1, r, "phi = ", "") '     decimal phi

eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
Term ()
END FUNCTION
END PROGRAM

