'Subject: Wilson's theorem: iff p is prime (p - 1)! Mod p = -1
'Author : Sjoerd.J.Schaper
'Date   : 08-21-2004
'Code   : XBasic adaptation demo
PROGRAM	"wilsonth"
VERSION	"01.00"
IMPORT	"bignumXB"
IMPORT	"xst"

DECLARE FUNCTION VOID Main()

FUNCTION VOID Main()
t0 = 0: t1 = 1: p = 2
k = LargeInit("wilsonth")
XstGetEnvironmentVariable(@"LARGEINT", @WrkD$)
XstGetSystemTime(@Tim)
XstClearConsole()

Readnr = OPEN(WrkD$ + "\\wilsonth", $$RD)

begin:
'p$ = INLINE$ (" p? ") '               input p < 8433
p$ = INFILE$ (Readnr)
IF INSTR(p$, "'") THEN GOTO begin
vp = XLONG(LEFT$(p$, 9))
IF vp > 8433 THEN GOTO begin
IF vp < 2 THEN GOTO eind
IF (vp AND 1) = 0 THEN GOTO begin '    skip even p
'
PRINT " p ="; vp
'
Fctl(p, vp - 1) '                      compute factorial
IF NOT Isf(p, 0) THEN
  Letf(t0, SLONG(vp))
  Inc(p, 1): Divd(p, t0, t1) '         (p - 1)! + 1 Mod p
  g$ = " " + p$ + " is " '             output test
  IF NOT Isf(p, 0) THEN g$ = g$ + "not "
  Prints(g$ + "prime", 1)
END IF
Prints("", 1)
GOTO begin
'
eind:
XstGetSystemTime(@Now)
g$ = STR$(SINGLE(Now - Tim) / 1000)
Prints("Timer:" + g$ + " s", 1)
CLOSE(Readnr)
Term ()
END FUNCTION
END PROGRAM
