'
' ####################
' #####  PROLOG  #####
' ####################
'
' A basic example of using gxml.
'
CONSOLE
'
	IMPORT "xst"
	IMPORT "xsx"
	IMPORT "gxml"
'
DECLARE FUNCTION Entry ()
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	XMLNODE root, node
	
	'load an xml file from XbliteDesigner
	root=XmlLoadFromFile ("XbliteDesigner.xml")
	
	'check xml version
	node=XmlGetChild (root, "xml", 0)
	IF XmlGetAttribute$ (node, "version")!="1.0" THEN ? "Invalid XML version."
	
	'print some info
	? "There are";;XmlGetNodes ();;"nodes present, and below is a list of them.\n"
	
	'print out node list
	? XmlNodeList$()

  a$ = INLINE$ ("Press Enter to quit >")

END FUNCTION
END PROGRAM